import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;


/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 08.12.2008
  * @author
  */
public class SkiGUI extends JFrame {
  // Anfang Attribute
  private final int MaxStarter = 20;
  private JLabel jLName1 = new JLabel();
  private JLabel jLStartnummer1 = new JLabel();
  private JLabel jLName2 = new JLabel();
  private JLabel jLStartnummer2 = new JLabel();
  private JLabel JLZeit = new JLabel();
  private JLabel jLStrafen = new JLabel();

  private JTable jTStart = new JTable(MaxStarter, 2);
  private JTable jTErgebnis = new JTable(MaxStarter, 4);

  private JLabel jLName = new JLabel();
  private JLabel jLNummer = new JLabel();
  private JTextField jTFNamen = new JTextField();
  private JTextField jTFNummer = new JTextField();

  private JButton jBaddLaeufer = new JButton();
  private JButton jBuTestliste = new JButton();
  private JButton jBStart = new JButton();
  private JButton jBReset = new JButton();
  private JButton jBBeenden = new JButton();

  private Vector<Skilaeufer> Starterliste = new Vector();
  private Vector<Skilaeufer> Ergebnisliste = new Vector();

  // Ende Attribute
  
  public SkiGUI(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

    int frameWidth = 708;
    int frameHeight = 386;
    setSize(frameWidth, frameHeight);

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);

    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    jBaddLaeufer.setBounds(16, 320, 129, 25);
    jBaddLaeufer.setText("Lufer erstellen");
    jBaddLaeufer.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          jBaddLaeufer_ActionPerformed(evt);
        }
      });
    cp.add(jBaddLaeufer);
    jBStart.setBounds(280, 256, 120, 25);
    jBStart.setText("Lufer starten");
    jBStart.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          jBStart_ActionPerformed(evt);
        }
      });
    cp.add(jBStart);
    jBReset.setBounds(420, 256, 120, 25);
    jBReset.setText("Neues Rennen");
    jBReset.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          jBReset_ActionPerformed(evt);
        }
      });
    cp.add(jBReset);
    jBBeenden.setBounds(560, 256, 120, 25);
    jBBeenden.setText("Beenden");
    jBBeenden.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
          jBBeenden_ActionPerformed(evt);
        }
      });
    cp.add(jBBeenden);
    jTErgebnis.setBounds(280, 32, 401, 209);
    cp.add(jTErgebnis);
    jTFNamen.setBounds(80, 256, 161, 24);
    jTFNamen.setText("");
    cp.add(jTFNamen);
    jLName1.setBounds(8, 8, 37, 16);
    jLName1.setText("Name");
    jLName1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLName1);
    jLStartnummer1.setBounds(144, 8, 75, 16);
    jLStartnummer1.setText("Startnummer");
    jLStartnummer1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLStartnummer1);
    jLStartnummer2.setBounds(384, 8, 75, 16);
    jLStartnummer2.setText("Startnummer");
    jLStartnummer2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLStartnummer2);
    jLName2.setBounds(280, 8, 37, 16);
    jLName2.setText("Name");
    jLName2.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLName2);
    JLZeit.setBounds(480, 8, 107, 16);
    JLZeit.setText("Zeit in Sekunden");
    JLZeit.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(JLZeit);
    jLStrafen.setBounds(584, 8, 42, 16);
    jLStrafen.setText("Strafen");
    jLStrafen.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLStrafen);
    jBuTestliste.setBounds(152, 320, 91, 25);
    jBuTestliste.setText("Testlliste");
    jBuTestliste.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBuTestliste_ActionPerformed(evt);
      }
    });
    cp.add(jBuTestliste);
    jLName.setBounds(16, 256, 37, 16);
    jLName.setText("Name");
    jLName.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLName);
    jLNummer.setBounds(16, 288, 51, 16);
    jLNummer.setText("Nummer");
    jLNummer.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLNummer);
    jTFNummer.setBounds(80, 288, 161, 24);
    jTFNummer.setText("");
    cp.add(jTFNummer);
    jTStart.setBounds(8, 32, 232, 208);
    cp.add(jTStart);
    // Ende Komponenten
    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  
  public void ListenAnzeigen() {
    // Daten aus dem Fachkonzept in die GUI bernehmen
    
    // Starterliste
    for (int i = 0; i < Starterliste.size(); i++) {
      Skilaeufer einSkilaeufer = Starterliste.get(i);
      jTStart.setValueAt(einSkilaeufer.Name, i, 0);
      jTStart.setValueAt(einSkilaeufer.Startnummer, i, 1);
    }
    for (int i = Starterliste.size(); i < jTStart.getRowCount(); i++) {
      jTStart.setValueAt("", i, 0);
      jTStart.setValueAt("", i, 1);
    }
    
    // Ergebnisliste
    for (int i = 0; i < Ergebnisliste.size(); i++) {
      Skilaeufer einLaeufer = Ergebnisliste.elementAt(i);
      jTErgebnis.setValueAt(einLaeufer.Name, i, 0);
      jTErgebnis.setValueAt("" + einLaeufer.Startnummer, i, 1);
      if (einLaeufer.Zeit == 4242)
        jTErgebnis.setValueAt("disqualifiziert" , i, 2);
      else
        jTErgebnis.setValueAt(einLaeufer.Zeit, i, 2);
      jTErgebnis.setValueAt(einLaeufer.Strafen, i, 3);
    }
    for (int i = Ergebnisliste.size(); i < jTErgebnis.getRowCount(); i++)
      for (int j = 0; j < 4; j++)
        jTErgebnis.setValueAt("", i, j);
  }

  public void NeuerLaeufer() {
    if (Starterliste.size() < MaxStarter) {
      String Name = jTFNamen.getText();
      String Nummer = jTFNummer.getText();
      if (!Name.equals("") && !Nummer.equals(""))
        Starterliste.add(new Skilaeufer(Name, Nummer));
      ListenAnzeigen();
    }
  }

  public void LaeuferStarten() {
    if (Starterliste.size() == 0) return;
    Skilaeufer derLaeufer = Starterliste.remove(0);
    derLaeufer.Starten();
    
    // Einfgestelle i suchen
    int i = 0;
    while (i < Ergebnisliste.size()) {
      Skilaeufer TempLaeufer = Ergebnisliste.elementAt(i);
      if (derLaeufer.Zeit <= TempLaeufer.Zeit) break;
      i++;
    }
    Ergebnisliste.insertElementAt(derLaeufer, i);
    ListenAnzeigen();
  }

  public void NeuStarten(){
    while (Ergebnisliste.size() > 0) {
      Skilaeufer einSkilaeufer = Ergebnisliste.remove(0);
      Starterliste.add(einSkilaeufer);
    }
    ListenAnzeigen();
  }
  
  public void ErzeugeTestliste() {
    Ergebnisliste.clear();
    Starterliste.clear();
    Starterliste.add(new Skilaeufer("Axel Schwei", "435"));
    Starterliste.add(new Skilaeufer("Ute Nsil", "436"));
    Starterliste.add(new Skilaeufer("Klara Fall", "132"));
    Starterliste.add(new Skilaeufer("Otto Paede", "056"));
    Starterliste.add(new Skilaeufer("Phil Frass", "847"));
    Starterliste.add(new Skilaeufer("Klaus Thaler", "107"));
    Starterliste.add(new Skilaeufer("Rainer Zufall", "841"));
    Starterliste.add(new Skilaeufer("Paul Ahner", "070"));
    Starterliste.add(new Skilaeufer("Anna Bolika", "822"));
    Starterliste.add(new Skilaeufer("Klaus Uhr", "324"));
    ListenAnzeigen();
  }
  
  public void jBaddLaeufer_ActionPerformed(ActionEvent evt) {
    NeuerLaeufer();
  }

  public void jBuTestliste_ActionPerformed(ActionEvent evt) {
    ErzeugeTestliste();
  }

  public void jBStart_ActionPerformed(ActionEvent evt) {
    LaeuferStarten();
  }

  public void jBReset_ActionPerformed(ActionEvent evt) {
    NeuStarten();
  }

  public void jBBeenden_ActionPerformed(ActionEvent evt) {
    System.exit(0);
  }

  // Ende Methoden
  public static void main(String[] args) {
    new SkiGUI("SkiGUI");
  }
}
